<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
<!-- 2025-02-03 ma. 10:39 -->
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1" />
<title>Reasonable Ontology Templates (OTTR)</title>
<meta name="author" content="Martin G. Skjæveland" />
<meta name="generator" content="Org Mode" />
<link rel="stylesheet" type="text/css" href="./inc/styleLR.css" />
<link rel="stylesheet" type="text/css" href="./inc/index-page.css" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.2.1/jquery.min.js"></script>
<script src="./inc/toc.js"></script>
<!--script src="./inc/landing-page.js"></script-->
<link rel="stylesheet" type="text/css" href="https://weblutra.ottr.xyz/js/weblutrabox.css" />
<script src="https://weblutra.ottr.xyz/js/weblutrabox.js"></script>
</head>
<body>
<div id="content" class="content">
<header>
<h1 class="title">Reasonable Ontology Templates (OTTR)</h1>
</header><div id="left">
<p><a href="#top">top</a><br/>
examples:
<span class="button" onclick="$('.examplebox').show(300) && $('div#left li:has(a[class|=example-title])').show(300)">show</span> /
<span class="button" onclick="$('.examplebox').hide(100) && $('div#left li:has(a[class|=example-title])').hide(100)">hide</span></p>

<h4>Contents</h4>
<div id="toc"></div>
</div>

<div id="right">
  <a id="top"></a>

  <!--div id="quick-links" class="noprint">
  <h4>Quick links</h4>
  <ul>
  <li class="internal"><a href="#Lutra">Lutra</a></li>
  <li class="external"><a href="https://primer.ottr.xyz/">primer</a></li>
  <li class="external"><a href="http://tpl.ottr.xyz">library</a></li>
  <li class="internal"><a href="#Specifications">specifications</a></li>
  <li class="internal"><a href="#Contact">contact</a></li>
  <li class="external"><a href="https://gitlab.com/ottr">git</a></li>
  </ul>
  </div-->

  <div class="landing-page" style="margin-top: 70px; margin-bottom: 100px; text-align: center">
  <img alt="OTTR" src="./logo/OTTR.jpg"/>
  <h1 style="margin-top: 50px; font-weight: bolder; font-size: 40px; text-align: center;">Reasonable Ontology Templates (OTTR)</h1>
  <p style="
  font-weight: bold; 
  text-align: left;
  max-width: 600px;
  margin-left: auto;
  margin-right: auto;
  ">
  Reasonable Ontology Templates (OTTR) is a language with supporting tools 
  for representing and instantiating RDF graph and OWL ontology modelling patterns. It is 
  designed to improve the efficiency and quality of building, using, and maintaining knowledge bases.
  </p>
  </div>


<div id="toc-content">

<div id="outline-container-org9d046b5" class="outline-2">
<h2 id="org9d046b5">Latest news</h2>
<div class="outline-text-2" id="text-org9d046b5">
<p>
For more news, see the <a href="./#News_archive">news archive</a>.
</p>

<dl class="org-dl">
<dt>2024-12-18</dt><dd><a href="https://drops.dagstuhl.de/entities/document/10.4230/TGDK.2.2.5">The complete set of specification of the OTTR framework has been publised as part of a special issue on resources in Transactions on Graph Data and Knowledge (TGDK)</a>. It collects years of developments on the framework and ideas for future work.</dd>

<dt>2024-06-18</dt><dd>Erik Snilsberg will present our extended abstract on the <a href="https://ceur-ws.org/Vol-3739/abstract-24.pdf">Foundations of Ontology Template Language OTTR</a> at the <a href="https://dl2024.w.uib.no/overview/">DL Workshop 2024</a>.</dd>

<dt>2024-02-02</dt><dd>If you are interested in making use of OTTR and semantic technologies in your data pipelines and for different reasons wish to use something else than Lutra, check out <a href="https://github.com/DataTreehouse/maplib">maplib</a> developed by <a href="https://www.data-treehouse.com/">Data Treehouse</a>: "maplib is a knowledge graph construction library for building RDF knowledge graphs using template expansion (OTTR Templates)."</dd>

<dt>2023-11-09</dt><dd><a href="https://www.grundfos.com/">Grundfos</a>' Industrial Ontology Engineering Platform uses OTTR. Read all about it in their ISWC 2023 industry paper: <a href="https://ceur-ws.org/Vol-3632/ISWC2023_paper_502.pdf">Building an Industrial Ontology Engineering Platform</a>, and in <a href="https://medium.com/wallscope/developing-ontology-tools-with-grundfos-d84a961bd4cd">https://medium.com/wallscope/developing-ontology-tools-with-grundfos-d84a961bd4cd</a>.</dd>

<dt>2023-11-07</dt><dd>Moritz Blum et al. shares <a href="https://ceur-ws.org/Vol-3636/paper8.pdf">Insights from an OTTR-centric Ontology Engineering Methodology</a> at WOP@ISWC2023.</dd>

<dt>2023-04-19</dt><dd>Martin G. Skjæveland is presenting OTTR to the Ontolog Forum on "Helping scientific researchers make better use of ontologies": <a href="https://ontologforum.com/index.php/ConferenceCall_2023_04_19">https://ontologforum.com/index.php/ConferenceCall_2023_04_19</a>, Video recording and slides available.</dd>

<dt>2022-08-17</dt><dd>On 2022-08-31 we are giving a talk on OTTR at <a href="https://ontocommons.eu/news-events/events/workshop-ontology-engineering-and-knowledge-graphs-tool-ecosystem">OntoCommons Workshop on Ontology Engineering and Knowledge Graphs tool ecosystem</a>. Registration is free and open!</dd>

<dt>2022-08-15</dt><dd>Our paper on abbreviations for complex OWL expressions has been accepted at <a href="https://kgsum.github.io/">KGSum 2022</a>.</dd>

<dt>2022-07-08</dt><dd>Our paper on syntactic modelling structures in ontologies  [<a href="#org43757c2">1</a>] has been accepted at <a href="https://iswc2022.semanticweb.org/">ISWC 2022</a>.</dd>
</dl>
</div>
</div>

<div id="outline-container-org4a10306" class="outline-2">
<h2 id="org4a10306">Introduction and Overview</h2>
<div class="outline-text-2" id="text-org4a10306">
<p>
Reasonable Ontology Templates (OTTR) is a framework and language for representing
ontology modelling patterns, and is designed to support interaction
with OWL or RDF knowledge bases at a higher level of abstraction,
using modelling patterns rather than OWL axioms or RDF triples. This
includes:
</p>
<ul class="org-ul">
<li>building knowledge bases by instantiating templates;</li>
<li>communicating (presenting, transferring and visualising) the
knowledge base as a set of template instances at different levels
of abstraction; and</li>
<li>securing and improving the quality and sustainability of the
knowledge base via structural and semantic analysis of the
templates used to construct the knowledge base.</li>
</ul>

<p>
OTTR templates and instances can be represented in <a href="#org53aa6d5">stOTTR</a>&#x2014;a custom-built
format similar to and based on RDF Turtle&#x2014;or in RDF using the <a href="#org4f4432a">wOTTR</a>
vocabulary. Instances may also be generated from spreadsheets using
<a href="#org41ade71">tabOTTR</a> or with mappings over various queryable sources using <a href="#orgd96d6b8">bOTTR</a>.
Our reference implementation <a href="./#Lutra">Lutra</a> supports these formats, and a web
interface <a href="https://weblutra.ottr.xyz">WebLutra</a> is available for testing. See also the
interactive examples below.
</p>

<p>
The project is in <a href="./#Development">active development</a>.
</p>

<iframe style="border: 1px solid #ccc;" src="https://player.vimeo.com/video/413131235" width="640" height="360"  allow="autoplay; fullscreen" allowfullscreen></iframe>

<div class="examplebox" id="orgbc22273">
<h4 class="example-title">Template instances</h4>

<p>
The <a href="https://protege.stanford.edu/ontologies/pizza/pizza.owl">Pizza ontology</a> is a well-known OWL tutorial ontology. The
ontology models the domain of pizzas and contains many specific
types of pizzas, such as Margherita. The Margherita pizza is
modelled as subclass of NamedPizza, originating from Italy and 
having exactly the toppings Tomato and Mozzarella, here shown in
Manchester syntax:
</p>

<pre class="example" id="orgb960bd6">
Class: Margherita

    SubClassOf: 
        NamedPizza,
        hasCountryOfOrigin some { Italy },
        hasTopping some Mozzarella,
        hasTopping some Tomato,
        hasTopping only 
            (Mozzarella or Tomato)
</pre>

<p>
The ontology contains 22 such types of pizzas, all following the same
modelling pattern as the Margherita pizza. Since this pattern is not
represented as a pattern (as no such concept exists in OWL), tasks
that are important for the efficient use and management of the
ontology, such as finding pattern instances, verifying consistent use
of the pattern, and updating the pattern, may require considerable
repetitive and laborious effort.
</p>

<p>
Using OTTR, we can record the pattern as an OTTR <i>template</i>, called,
<code>o-pizza:NamedPizza</code>, which takes 3 arguments: the name or IRI, an optional
country of origin, and a list of toppings; and easily make multiple
<i>instances</i> of the pattern. Click "Run" below to expand the instances using
<a href="./#Lutra">WebLutra</a>.
</p>

<div class="weblutra" id="org8053590">
<div class="input" id="org3bffd78">
<p>
<textarea cols="80" rows="3">

o-pizza:NamedPizza(ex:Margherita, ex:Italy, (ex:Mozzarella, ex:Tomato)) .
o-pizza:NamedPizza(ex:Hawaii, none, (ex:Cheese, ex:Ham, ex:Pineapple)) .</textarea>
</p>

</div>

</div>

<p>
The design of the pattern, the OTTR template, is kept in a single
location definition and can be updated without changing the instances
of the templates (unless the input arguments must also be
updated). In the above example the template definition is fetched
from its IRI address when the instances are expanded.
</p>

<p>
This screen recording shows how the example is expanded with our
reference implementation <a href="./#Lutra">Lutra</a>.
</p>


<figure id="orgc261cbd">
<img src="./examples/gifs/example1.gif" alt="example1.gif" />

</figure>

</div>
</div>

<div id="outline-container-orged5dbba" class="outline-3">
<h3 id="orged5dbba">Language features</h3>
<div class="outline-text-3" id="text-orged5dbba">
<p>
The OTTR template language has the following core constructs and features:
</p>

<ul class="org-ul">
<li>A <i>template</i> identifies and captures a modelling pattern as a
<i>parameterised</i> RDF graph or OWL ontology pattern.</li>
<li>A template <i>instance</i> represents a replica of the template which
replaces the template's parameters with the instance's
<i>arguments</i>.</li>
<li>A template definition may be nested, i.e., a template is
specified from other templates.</li>
<li>Template parameters may be
<ul class="org-ul">
<li><i>typed</i>&#x2014;specifying the permissible type/datatype of arguments</li>
<li>set to be <i>optional</i>, allowing missing arguments,</li>
<li>set to be <i>non-blank</i>, disallowing a blank node as argument, and</li>
<li>be given a <i>default value</i>.</li>
</ul></li>
<li>Template instances accept any RDF resource as argument, including
lists.</li>
<li><i>List expanders</i> support iterating over list arguments,
supporting compact specification of multiple template instances.</li>
</ul>

<div class="examplebox" id="org858149a">
<h4 class="example-title">Template definition</h4>

<p>
The <code>NamedPizza</code> template is listed below in the "library" box of the form
(using a different IRI than the above example to avoid conflict).  
</p>

<p>
The first line contains the signature of the template. It specifies
the <i>template name</i> and its <i>parameters</i>. The parameters can be
<i>typed</i> and set as non-optional or optional, e.g., the <code>?country</code>
parameter optionally takes an individual as argument, and the
<code>?toppings</code> parameter is not optional and takes a non-empty list of
classes.
</p>

<p>
The remaining lines is the body of the template, and specifies
the pattern that the template represents, by instantiating other
templates. All these instances model common OWL axioms. The <code>cross</code> is
a <i>list expander</i> specifying that an instance of the
<code>SubObjectSomeValuesFrom</code> template will be created for <i>each element</i> in
the <code>?toppings</code> list argument. Note that the <code>?toppings</code> list argument is
also used (now as a list) to create a OWL union class which is used as
qualifier for the <code>SubObjectAllValuesFrom</code> axiom in.
</p>

<p>
Click "Run" to expand the instances. 
</p>

<div class="weblutra" id="orgd6e0e60">
<div class="input" id="org39874bd">
<p>
<textarea cols="80" rows="3">

ex:NamedPizzaTemplate(ex:Margherita, ex:Italy, (ex:Mozzarella, ex:Tomato)) .
ex:NamedPizzaTemplate(ex:Hawaii, none, (ex:Cheese, ex:Ham, ex:Pineapple)) .</textarea>
</p>

</div>
<div class="library" id="orgafa54a6">
<p>
<textarea cols="80" rows="8">

ex:NamedPizzaTemplate[owl:Class ?pizza, ? owl:NamedIndividual ?country, NEList<ottr:IRI> ?toppings] :: {
  ax:SubClassOf(?pizza, ex:NamedPizza),
  ax:SubObjectHasValue(?pizza, ex:hasCountryOfOrigin, ?country),
  ax:SubObjectAllValuesFrom(?pizza, ex:hasTopping, _:toppingsUnion),
  rstr:ObjectUnionOf(_:toppingsUnion, ?toppings),
  cross | ax:SubObjectSomeValuesFrom(?pizza, ex:hasTopping, ++?toppings)
} .</textarea>
</p>

</div>

</div>

<p>
This screen recording shows how the example is expanded with <a href="./#Lutra">Lutra</a>.
</p>


<figure id="org4ebaf93">
<img src="./examples/gifs/example2.gif" alt="example2.gif" />

</figure>

</div>
</div>
</div>

<div id="outline-container-orga22e218" class="outline-3">
<h3 id="orga22e218">Benefits</h3>
<div class="outline-text-3" id="text-orga22e218">
<p>
We believe the benefits of using OTTR are many:
</p>

<dl class="org-dl">
<dt>Better abstractions</dt><dd>The use of templates as building blocks
for knowledge bases makes knowledge bases easier to understand
and work with since modelling constructs are expressed using
patterns at a suitable abstraction level rather than with
low-level RDF triples or OWL axioms.</dd>
<dt>Uniform modelling</dt><dd>Knowledge bases built using a
well-designed template library makes its modelling more
uniform, which can greatly improves its ease of use and
maintenance.</dd>
<dt>Modular, encapsulated patterns</dt><dd>The fact that templates can be
defined by referring to other templates follows the <a href="https://en.wikipedia.org/wiki/Don%27t_repeat_yourself"><i>don't
repeat yourself</i></a> (DRY) principle, and leads to templates that
are easier to maintain and, in many cases, easier to
understand.</dd>
<dt>Separation of design and content</dt><dd>Instantiable template
naturally establishes a clear separation between the design of
the knowledge base&#x2014;represented by templates, and the bulk
content of the knowledge base&#x2014;represented by template
instances. The templates and the template instances can then
typically be managed by different competencies and tools:
templates are managed by ontology experts using specialised
tooling such as ontology editors and reasoners, while
templates instances are created by domain experts using tools
they are familiar with, e.g., spreadsheets.</dd>
<dt>Open standards support</dt><dd>OTTR is designed to work smoothly with
relevant core W3C standards, such as RDF, OWL, SPARQL, XML,
XSD, SAWSDL, XSLT. (For the XML standards family only
rudimentary prototypes have been tested.)</dd>
<dt>Publish, share and reuse</dt><dd>Templates can be published and shared
using common web publishing practices, such as <a href="https://www.w3.org/TR/ld-bp/">Best Practices
for Publishing Linked Data</a>.</dd>
<dt>Tool support for maintenance</dt><dd>The formal basis of OTTR
template, i.e., RDF graphs and OWL ontologies, allow templates
to be analysed and quality assessed using OWL reasoners, but
also using well-known ideas from software engineering, such as
identifying redundancies and suggesting refactoring for poorly
integrated templates.</dd>
</dl>
</div>
</div>


<div id="outline-container-org166014e" class="outline-3">
<h3 id="org166014e">Tool and language support</h3>
<div class="outline-text-3" id="text-org166014e">
<p>
Templates and instances can be serialised as ordinary RDF graphs
and OWL ontologies using a dedicated OWL vocabulary, called <a href="#org4f4432a">wOTTR</a>.
This allows templates and instances to be constructed, stored,
edited and quality assessed using existing W3C languages and tools,
such as OWL reasoners, SPARQL query engines and RDF triple stores.
</p>

<div class="examplebox" id="org4b9cae7">
<h4 class="example-title">RDF/OWL serialisation</h4>

<p>
In the preceding examples we have used the serialisation called <a href="#org53aa6d5">stOTTR</a>
that is made for compactly representing template and instances.
</p>

<p>
There is also a OWL vocabulary, <a href="#org4f4432a">wOTTR</a>, for representing OTTR templates
and instances. The RDF/OWL serialisation of the NamedPizza template is
seen below, in a compacted version. It is published at its IRI
<a href="http://tpl.ottr.xyz/pizza/0.1/NamedPizza">http://tpl.ottr.xyz/pizza/0.1/NamedPizza</a>.
</p>

<p>
Lines 1&#x2013;6 contain the template signature, while the remaining lines
contain the template pattern.
</p>
<pre class="example" id="org7309d64">
<span class="linenr"> 1: </span>o-pizza:NamedPizza  a  ottr:Template ;
<span class="linenr"> 2: </span>  ottr:parameters  ( 
<span class="linenr"> 3: </span>    [ ottr:variable _:b0 ; ottr:type owl:Class ;  ]
<span class="linenr"> 4: </span>    [ ottr:variable _:b1 ; ottr:type owl:NamedIndividual ; ottr:modifier  ottr:optional ]
<span class="linenr"> 5: </span>    [ ottr:variable _:b2 ; ottr:type ( ottr:NEList ottr:IRI ) ]
<span class="linenr"> 6: </span>  ) ;
<span class="linenr"> 7: </span>  ottr:pattern     
<span class="linenr"> 8: </span>    [ ottr:of  ax:SubObjectAllValuesFrom
<span class="linenr"> 9: </span>      ottr:arguments ( _:b0 pz:hasTopping _:b3 ) ] ,
<span class="linenr">10: </span>    [ ottr:of ax:SubClassOf
<span class="linenr">11: </span>      ottr:arguments ( _:b0 pz:NamedPizza ) ] ,
<span class="linenr">12: </span>    [ ottr:of rstr:ObjectUnionOf
<span class="linenr">13: </span>      ottr:arguments ( _:b3 _:b2 ) ] ,
<span class="linenr">14: </span>    [ ottr:of ax:SubObjectSomeValuesFrom ;
<span class="linenr">15: </span>      ottr:modifier ottr:cross ;
<span class="linenr">16: </span>      ottr:arguments ( 
<span class="linenr">17: </span>        [ ottr:value  _:b0 ]
<span class="linenr">18: </span>        [ ottr:value  pz:hasTopping ]
<span class="linenr">19: </span>        [ ottr:modifier  ottr:listExpand ; ottr:value _:b2 ]
<span class="linenr">20: </span>      ) 
<span class="linenr">21: </span>    ] ,
<span class="linenr">22: </span>    [ ottr:of ax:SubObjectHasValue
<span class="linenr">23: </span>      ottr:arguments ( _:b0 pz:hasCountryOfOrigin _:b1 ) ] .
</pre>

</div>

<p>
Other serialisation formats are available for representing
templates and instances, see <a href="./#Specifications">Specifications</a>.
</p>

<div class="examplebox" id="org04ec4e1">
<h4 class="example-title">Instances in Excel</h4>

<p>
<a href="#org41ade71">tabOTTR</a> is a small "markup" language for tabular formats such as Excel
used to specify template instances.
</p>

<p>
Below is a example showing the same instances given in an example
over. The rows 1&#x2013;4 specify the input format of the instances given in
rows 5&#x2013;6.
</p>

<table>


<colgroup>
<col  class="org-right" />

<col  class="org-left" />

<col  class="org-left" />

<col  class="org-left" />
</colgroup>
<tbody>
<tr>
<td class="org-right">1</td>
<td class="org-left"><code>#OTTR</code></td>
<td class="org-left"><code>template</code></td>
<td class="org-left"><code>http://tlp.ottr.xyz/pizza/0.1/NamedPizza</code></td>
</tr>

<tr>
<td class="org-right">2</td>
<td class="org-left"><code>1</code></td>
<td class="org-left"><code>2</code></td>
<td class="org-left"><code>3</code></td>
</tr>

<tr>
<td class="org-right">3</td>
<td class="org-left"><code>iri</code></td>
<td class="org-left"><code>iri</code></td>
<td class="org-left"><code>iri+</code></td>
</tr>

<tr>
<td class="org-right">4</td>
<td class="org-left"><code>Pizza</code></td>
<td class="org-left"><code>Country</code></td>
<td class="org-left"><code>Toppings</code></td>
</tr>

<tr>
<td class="org-right">5</td>
<td class="org-left"><code>Margherita</code></td>
<td class="org-left"><code>Italy</code></td>
<td class="org-left"><code>Mozzarella</code> &vert; <code>Tomato</code></td>
</tr>

<tr>
<td class="org-right">6</td>
<td class="org-left"><code>Hawaii</code></td>
<td class="org-left">&#xa0;</td>
<td class="org-left"><code>Cheese</code> &vert; <code>Ham</code> &vert; <code>Pineapple</code></td>
</tr>

<tr>
<td class="org-right">7</td>
<td class="org-left"><code>#OTTR</code></td>
<td class="org-left"><code>end</code></td>
<td class="org-left">&#xa0;</td>
</tr>
</tbody>
</table>



<p>
The spreadsheet <a href="./examples/ex3/PizzaOntologyInstances.xlsx">PizzaOntologyInstances.xlsx</a> contains several instances
of the <a href="http://tpl.ottr.xyz/pizza/0.1/NamedPizza">NamedPizza</a> template.
</p>

<p>
Try to download the spreadsheet and expand it using the form below.
</p>

<div class="weblutra" id="org5a3803a">
<p>

</p>

<input type="hidden" class="reset-value" data-name="fetchMissing" value="true"/>
<div class="menu">tabOTTR Excel file<br/>
<input id="fileInput" type="file" name="fileInput">
<input type="hidden" name="inputFormat" value="tabottr"/>
</div>

</div>

<p>
This screen recording shows how the example is expanded with <a href="./#Lutra">Lutra</a>.
</p>


<figure id="org5e9c28e">
<img src="./examples/gifs/example3.gif" alt="example3.gif" />

</figure>

</div>

<div class="examplebox" id="org788bd6c">
<h4 class="example-title">Extracting instances from queryable sources</h4>

<p>
<a href="#orgd96d6b8">bOTTR</a> is a language for specifying mappings between queries over the
sources to given templates. bOTTR hence allows multiple data sources
on different formats to be integrated via OTTR templates into a single
RDF/OWL representation.
</p>

<p>
bOTTR currently supports queries over JDBC, including CSV files, and
SPARQL queries (over SPARQL endpoints and RDF files).
</p>

<p>
The following map instantiates the NamedPizza template by querying the
PizzaOntology. 
</p>

<div class="weblutra" id="org3ae0f23">
<p>

</p>

<input type="hidden" class="reset-value" data-name="inputFormat" value="bottr"/>
<input type="hidden" class="reset-value" data-name="fetchMissing" value="true"/>
<div class="input" id="orgf5ff366">
<p>
<textarea cols="80" rows="37">
[] a ottr:InstanceMap ;
    ottr:template <http://tpl.ottr.xyz/pizza/0.1/NamedPizza> ;
    ottr:query """
PREFIX  p: <http://www.co-ode.org/ontologies/pizza/pizza.owl#>
SELECT  ?pizza  ?country  (GROUP_CONCAT(DISTINCT ?topping; SEPARATOR=";") AS ?toppingslist)
WHERE {
    ?pizza  rdfs:subClassOf  p:NamedPizza ;
            rdfs:subClassOf [
                owl:allValuesFrom   [ owl:unionOf ?toppings ; rdf:type owl:Class ] ;
                owl:onProperty      p:hasTopping ;
                rdf:type            owl:Restriction ] ;
            rdfs:subClassOf [
                owl:onProperty      p:hasTopping ;
                owl:someValuesFrom  ?topping ;
                rdf:type            owl:Restriction ] .

    ?toppings  (rdf:rest)*/rdf:first ?topping .

    OPTIONAL {
        ?pizza  rdfs:subClassOf [
                  owl:hasValue    ?country ;
                  owl:onProperty  p:hasCountryOfOrigin ;
                  rdf:type        owl:Restriction ] .
    }                
  }
GROUP BY ?pizza ?country
LIMIT 1
""" ;
    ottr:source [ a ottr:RDFFileSource ;
                  ottr:sourceURL "https://protege.stanford.edu/ontologies/pizza/pizza.owl" ] ;
    ottr:argumentMaps (
      [] # use default map
      [] # use default map
      [ ottr:type (rdf:List ottr:IRI); 
        ottr:translationSettings [ ottr:listSep ";"] 
      ]
   ) .</textarea>
</p>

</div>

</div>

</div>
</div>
</div>
</div>

<div id="outline-container-org45f26ed" class="outline-2">
<h2 id="org45f26ed">Lutra</h2>
<div class="outline-text-2" id="text-org45f26ed">
<p>
Lutra is our open source (LGPL licence) reference implementation of
the OTTR language. Lutra can read and write OTTR templates and
instances on different serialisation formats, and expand instances
into regular RDF graphs.  Lutra is written in Java
and is available as a command line interface, and as feature limited
version web application: <a href="https://weblutra.ottr.xyz/">https://weblutra.ottr.xyz/</a>
</p>

<ul class="org-ul">
<li><a href="https://gitlab.com/ottr/">https://gitlab.com/ottr/</a></li>
<li><a href="https://gitlab.com/ottr/lutra/lutra/-/releases">Releases</a></li>
<li><a href="https://gitlab.com/ottr/lutra/lutra">Source code</a></li>
<li><a href="https://gitlab.com/ottr/lutra/lutra/issues">Issues</a></li>
</ul>

<div class="examplebox" id="orgfa4974a">
<p>

</p>

<p>
This is the command line interface of Lutra:
</p>

<div class="org-src-container">
<pre class="src src-sh">java -jar lutra.jar --version
java -jar lutra.jar --help
</pre>
</div>

<pre class="example" id="org98c8ffe">
0.6.19
Usage: lutra [-fhV] [--debugStackTrace] [--quiet] [--stdout] [-F=&lt;fetchFormat&gt;]
             [--haltOn=&lt;haltOn&gt;] [-I=&lt;inputFormat&gt;] [-L=&lt;libraryFormat&gt;]
             [-m=&lt;mode&gt;] [--messageLinePrefix=&lt;linePrefix&gt;] [-o=&lt;out&gt;]
             [-O=&lt;outputFormat&gt;] [-p=&lt;prefixes&gt;] [-e=&lt;extensions&gt;[,
             &lt;extensions&gt;...]]... [-E=&lt;ignoreExtensions&gt;[,
             &lt;ignoreExtensions&gt;...]]... [-l=&lt;library&gt;]... [&lt;inputs&gt;...]

DESCRIPTION:
Reference implementation for OTTR Templates. Use for expanding template
instances and template definitions, translating between different formats and
for checking the integrity of template libraries.

PARAMETERS:
      [&lt;inputs&gt;...]         Files of instances to which operations are to be
                              applied.

OPTIONS:
      --debugStackTrace     This enables printing a regular java stack trace
                              for error messages.Enabling this flag will not
                              deteriorate performance.
                            default: false)
  -e, --extension=&lt;extensions&gt;[,&lt;extensions&gt;...]
                            File extension of files to use as input to template
                              library.
                            (default: [])
  -E, --ignoreExtension=&lt;ignoreExtensions&gt;[,&lt;ignoreExtensions&gt;...]
                            File extensions of files to ignore as input to
                              template library.
                            (default: [])
  -f, --fetchMissing        Fetch missing template dependencies. It is here
                              assumed that templates' definitions are
                              accessible via their IRI, that is, the IRI is
                              either a path to a file, a URL, or similar.
                            (default: false)
  -F, --fetchFormat=&lt;fetchFormat&gt;
                            The input format of the templates fetched via the
                              -f flag (registered formats: wottr, stottr)
  -h, --help                Show this help message and exit.
      --haltOn=&lt;haltOn&gt;     Halt execution upon receiving messages with a
                              severity equal to or greater than this value.
                            (legal values: INFO, WARNING, ERROR, FATAL;
                              default: ERROR)
  -I, --inputFormat=&lt;inputFormat&gt;
                            Input format of instances.
                            (registered formats: wottr, stottr, tabottr, bottr
                              default: wottr)
  -l, --library=&lt;library&gt;   Folder containing templates to use as library. Can
                              be used multiple times for multiple libraries.
  -L, --libraryFormat=&lt;libraryFormat&gt;
                            The input format of the libraries. If omitted, all
                              available formats are attempted.
                            (registered formats: wottr, stottr)
  -m, --mode=&lt;mode&gt;         The mode of operation to be applied to input.
                            (legal values: expand, expandLibrary, format,
                              formatLibrary, lint, checkSyntax, docttrLibrary;
                              default: expand)
      --messageLinePrefix=&lt;linePrefix&gt;
                            Set line prefix for output messages (use e.g. '#'
                              to make output become comments).
                            (default: )
  -o, --output=&lt;out&gt;        Path for writing output.
  -O, --outputFormat=&lt;outputFormat&gt;
                            Output format of output of operation defined by the
                              mode.
                            (registered formats: wottr, stottr, tabottr, bottr;
                              default: wottr)
  -p, --prefixes=&lt;prefixes&gt; Path to RDF file containing prefix declarations to
                              be used when rendering output.    Any other data
                              in the file is read, but ignored.
      --quiet               Suppress all messages, including errors and
                              warnings.
                            (default: false)
      --stdout              Print system of operations to standard out.
                            (default: false)
  -V, --version             Print version information and exit.

LINKS:
Website:  https://ottr.xyz
Primers:  https://primer.ottr.xyz
Git repo: https://gitlab.com/ottr/lutra/lutra
</pre>

</div>
</div>
</div>

<div id="outline-container-org5affe5e" class="outline-2">
<h2 id="org5affe5e">Specifications</h2>
<div class="outline-text-2" id="text-org5affe5e">
<p>
The OTTR language is formally defined in a series of specifications
listed below. For a more light-weight introduction to OTTR, visit
the primer: <a href="https://primer.ottr.xyz">https://primer.ottr.xyz</a>
</p>

<dl class="org-dl">
<dt><a id="org507daff"></a>Concepts and Abstract Model for Reasonable Ontology Templates (mOTTR)</dt><dd>mOTTR defines the fundamentals of OTTR.
<ul class="org-ul">
<li>Release: <a href="https://spec.ottr.xyz/mOTTR/0.1/">https://spec.ottr.xyz/mOTTR/0.1/</a></li>
<li>Development: <a href="https://dev.spec.ottr.xyz/mOTTR/">https://dev.spec.ottr.xyz/mOTTR/</a></li>
</ul></dd>

<dt><a id="org8af8ef1"></a>Adapting Reasonable Ontology Templates to RDF (rOTTR)</dt><dd>rOTTR specifies how mOTTR is adapted to fit the RDF.
<ul class="org-ul">
<li>Release: <a href="https://spec.ottr.xyz/rOTTR/0.2/">https://spec.ottr.xyz/rOTTR/0.2/</a></li>
<li>Development: <a href="https://dev.spec.ottr.xyz/rOTTR/">https://dev.spec.ottr.xyz/rOTTR/</a></li>
</ul></dd>

<dt><a id="org4f4432a"></a>Web Reasonable Ontology Templates (wOTTR)</dt><dd>wOTTR
defines a RDF serialisation format for OTTR.
<ul class="org-ul">
<li>Release: <a href="https://spec.ottr.xyz/wOTTR/0.4/">https://spec.ottr.xyz/wOTTR/0.4/</a></li>
<li>Development: <a href="https://dev.spec.ottr.xyz/wOTTR/">https://dev.spec.ottr.xyz/wOTTR/</a></li>
</ul></dd>

<dt><a id="org53aa6d5"></a>Terse Syntax for Reasonable Ontology Templates (stOTTR)</dt><dd>stOTTR defines a compact serialisation format for OTTR, aimed
to be easy to read and write.
<ul class="org-ul">
<li>Release: <a href="https://spec.ottr.xyz/stOTTR/0.1/">https://spec.ottr.xyz/stOTTR/0.1/</a></li>
<li>Development: <a href="https://dev.spec.ottr.xyz/stOTTR/">https://dev.spec.ottr.xyz/stOTTR/</a></li>
</ul></dd>

<dt><a id="org41ade71"></a>Tabular Reasonable Ontology Template Instances (tabOTTR)</dt><dd>tabOTTR defines a input format for bulk OTTR template
instantiation for tabular file formats such as CSV, TSV and
Excel spreadsheets.
<ul class="org-ul">
<li>Release: <a href="https://spec.ottr.xyz/tabOTTR/0.3/">https://spec.ottr.xyz/tabOTTR/0.3/</a></li>
<li>Development: <a href="https://dev.spec.ottr.xyz/tabOTTR/">https://dev.spec.ottr.xyz/tabOTTR/</a></li>
</ul></dd>

<dt><a id="orgd96d6b8"></a> Batch Instantiation of OTTR templates (bOTTR)</dt><dd>An Extract-Transform-Load (ETL) mapping language for
instantantiating OTTR templates from existing external sources.
<ul class="org-ul">
<li>Release: <a href="https://spec.ottr.xyz/bOTTR/0.1/">https://spec.ottr.xyz/bOTTR/0.1/</a></li>
<li>Development: <a href="https://dev.spec.ottr.xyz/bOTTR/">https://dev.spec.ottr.xyz/bOTTR/</a></li>
</ul></dd>
</dl>



<figure id="org915b7ab">
<img src="img/spec-overview.png" alt="spec-overview.png" />

<figcaption><span class="figure-number">Figure 1: </span>Dependencies between OTTR specifications</figcaption>
</figure>
</div>
</div>

<div id="outline-container-org3db01d7" class="outline-2">
<h2 id="org3db01d7">Template library</h2>
<div class="outline-text-2" id="text-org3db01d7">
<p>
A library of published OTTR templates is available at <a href="http://tpl.ottr.xyz">tpl.ottr.xyz</a>.
</p>

<p>
This library contains many templates that model common patterns for
the W3C standards OWL, RDFS and RDF. The library also includes other
more complex patterns that are useful for understanding how OTTR
templates may be built and used.
</p>

<p>
Our intention is that this library will grow to contain OTTR
templates for many useful patterns and for many prominent
vocabularies. A set of <a href="https://gitlab.com/ottr/templates">guidelines for managing the library</a> is under
development.
</p>


<p>
Note: The library of templates in the "legacy" version of the wOTTR
format is now outdated and no longer available through the service
at <code>library.ottr.xyz</code>. However, they are still available at their
IRI, and at the archived repositories
<a href="https://gitlab.com/ottr/candidate/">https://gitlab.com/ottr/candidate/</a> and
<a href="https://gitlab.com/ottr/draft/">https://gitlab.com/ottr/draft/</a>.
</p>
</div>
</div>

<div id="outline-container-org45b5c56" class="outline-2">
<h2 id="org45b5c56">Methodology</h2>
<div class="outline-text-2" id="text-org45b5c56">
<p>
We have yet to properly specify and formally evaluate a
tool-supported methodology for the development and maintenance of
knowledge bases using OTTR templates. However, we believe the
abstraction mechanism that OTTR templates provide can work in a
similar manner as application programming interfaces (APIs) work for
programming and software engineering. We anticipate the following
roles for such a methodology:
</p>

<dl class="org-dl">
<dt>Template library designer</dt><dd>This is the designer and maintainer
of the basic and core template libraries.  The job of the
library designer is to construct well-designed interfaces,
i.e., capture modelling patterns using OTTR templates, for
basic RDF and OWL vocabularies, such as the RDF and OWL
vocabularies themselves, but also other vocabularies like <a href="https://www.w3.org/2004/02/skos/vocabs">SKOS</a>,
<a href="http://dublincore.org/schemas/rdfs/">Dublin Core</a>, <a href="http://basic-formal-ontology.org/">BFO</a>, and possibly also special purpose
vocabularies like <a href="https://bioportal.bioontology.org/ontologies/GALEN">Galen</a> where ontological expertise is required
to correctly understand the vocabulary. Hence, this role
requires good insight into the underlying logical languages,
i.e., RDF and OWL, and the OTTR language.  There is currently
no special-purpose editor for this role; we recommend that you
use your favourite text-editor to create templates "by hand" in
stOTTR syntax, and use Lutra to check the correctness of your
templates.</dd>
<dt>Template programmer</dt><dd>The job of the template programmer is to
bridge the abstractions over the logical vocabulary created by
the template library designer with the conceptualisation of
domain experts. The is achieved by creating <i>user-facing</i>
templates that combine and restrict already existing templates
available in template libraries, to create new templates that
capture specific modelling patterns for given tasks.  The
programmer must have a firm grasp on the users' needs and task,
but need "only" to understand the templates in the library and
to lesser extent understand the formal logic that underlies
these templates. This requires that the templates in the
library are well-documented. The user-facing templates form the
interface for data input (and possibly output) that is
presented to the domain expert.  There is currently no tool
support for this role, other than what is available to the
library designer. We have ideas for a standalone tool to
support the template programmer.</dd>
<dt>Domain expert</dt><dd>The domain expert is equipped by the template
programmer with a well-designed set of
user-facing templates. However, for the domain
expert these templates present themselves only in
the form of structurally simple spreadsheet
formats, i.e., tabular forms with column headers
and explanations. We assume that it is possible
to create such formats that lie close to the
domain experts existing conceptualisation of the
domain. This would make them easy to understand
and use. "Using" means here 1) creating template
instances by filling in data row in the tabular
format, or 2) using the format as a query, in
which the results of the query will be presented
as data rows in the same format. The tabOTTR
specification and Lutra provide support for this
user role.</dd>
</dl>


<p>
An input format prepared by the template programmer and filled with
data by the domain expert can, using the template expansion
mechanism, be consistently translated into a knowledge base using
the vocabulary prescribed by the templates.  The separation of
responsibility between the roles allows a single template library
designer to serve multiple template programmers, which in turn can
serve multiple domain experts.  This fits the skill and tools sets
that information modelling projects typically have available, e.g.,
domain experts are used to working with spreadsheets and rarely have
the competence required for working with ontology editors, while
there are usually fewer people that have the required logical
background and competence for building and maintaining semantic
knowledge bases.
</p>


<figure id="orgee758bf">
<img src="img/methodology.png" alt="methodology.png" />

<figcaption><span class="figure-number">Figure 2: </span>Responsibilities and competencies of methodology roles</figcaption>
</figure>
</div>
</div>


<div id="outline-container-orgb5bfde4" class="outline-2">
<h2 id="orgb5bfde4">Development</h2>
<div class="outline-text-2" id="text-orgb5bfde4">
<p>
The technology surrounding and theory underlying OTTR is under
active development, and the use of OTTR templates for construction
of sustainable knowledge bases is gaining industrial interest.
</p>

<p>
All our publicly available development is available at GitLab:
<a href="https://gitlab.com/ottr">gitlab.com/ottr</a>, where our work is organised into different subgroups
and repositories:
</p>

<ul class="org-ul">
<li><a href="./#Lutra">Lutra</a>,</li>
<li><a href="./#Specifications">specifications</a>, and</li>
<li><a href="./#Template_library">template library</a></li>
</ul>

<p>
Our future plans are to develop:
</p>
<ul class="org-ul">
<li>new version of Lutra with increased performance and with a
code-base that is better suited for template library analysis</li>
<li>formal specification of OTTR serialisation formats</li>
<li>better understanding of industrial requirements</li>
<li>updated template library and library maintenance procedures and
tools</li>
<li>translating templates to SPARQL queries</li>
<li>improved techniques for template library analysis</li>
<li>specialised tools for designing templates</li>
<li>visualisation and presentation tools for templates</li>
<li>formalised methodology for constructing ontologies</li>
<li>support for more input data formats</li>
</ul>

<p>
We have also done experimental work on:
</p>
<ul class="org-ul">
<li>translating templates to SAWSDL annotated XSD format descriptions</li>
<li>translating templates to XSLT transformations from XML on
generated XSD formats to expanded RDF/XML</li>
</ul>
</div>
</div>

<div id="outline-container-org58f7fc2" class="outline-2">
<h2 id="org58f7fc2">Theoretical foundation</h2>
<div class="outline-text-2" id="text-org58f7fc2">
<p>
Different theoretical foundations for OTTR templates have been
examined: 
</p>

<ul class="org-ul">
<li>OTTR templates as RDF macros [<a href="#orgd75ee02">6</a>]</li>
<li>OTTR templates as parameterised description logic knowledge bases
[<a href="#org82bb7ab">10</a>]</li>
</ul>

<p>
For the implemented version of OTTR templates, which is the version
presented throughout these webpages, we consider OTTR templates as
RDF macros: The OTTR template functionality is implemented as a
recursive, non-cyclic macro mechanism for RDF statements, where OTTR
template instances are unfolded into a regular RDF or RDF/OWL
knowledge base by recursively replacing template instances with
their definition. This process terminates with a set of <i>base
templates</i> that directly represent a knowledge base on RDF or
RDF/OWL format.
</p>

<p>
For more information, check out our <a href="#org4a1b421">Publications</a>.
</p>
</div>

<div id="outline-container-org4a1b421" class="outline-3">
<h3 id="org4a1b421">Publications</h3>
<div class="outline-text-3" id="text-org4a1b421">
<p>
Our publications are listed below grouped according to topic and
sorted after publication year.
</p>
</div>

<div id="outline-container-org1fbbd76" class="outline-4">
<h4 id="org1fbbd76">The OTTR Framework</h4>
<div class="outline-text-4" id="text-org1fbbd76">
<ol class="org-ol">
<li><p>
<a id="org2c288b5"></a>Martin G. Skjæveland and Leif Harald Karlsen. <a href="https://drops.dagstuhl.de/entities/document/10.4230/TGDK.2.2.5"><b>The Reasonable Ontology Templates Framework</b></a>.  Transactions on
Graph Data and Knowledge (TGDK) Volume 2, Issue 2. TGDK 2(2):
5:1-5:54 (2024) 
</p>
<details>
<summary>Abstract</summary>
<blockquote>
Reasonable Ontology Templates (OTTR) is a framework for representing encodings 
of ontology patterns and aimed to increase the efficiency and quality
of ontology engineering. This paper presents the current status and future ideas of
the main public library of OTTR templates. We describe the current contents of
the library, the rationale behind how templates are versioned and managed over
their lifetime, how templates are documented and published, and the technical
solution used.
</blockquote>
</details></li>

<li><p>
<a id="org9534601"></a>Erik Snilsberg, Leif Harald Karlsen, Egor V. Kostylev, Martin G. Skjæveland: <b><a href="https://ceur-ws.org/Vol-3739/abstract-24.pdf">Foundations of Ontology Template Language OTTR (Extended Abstract)</a></b> Description Logics 2024.
</p>
<details>
<summary>Abstract</summary>
<blockquote>
OTTR is a template language for the Semantic Web data and knowledge representation languages RDF and OWL.
OTTR sees use as a key technology in the Semantic Web systems and already gained popularity both in academia
and industry. OTTR is also in active development, which is, however, limited by the fact that little is known
about its theoretical aspects. In this extended abstract we begin to close this gap by laying the foundations of
OTTR. To this end, we first introduce a mathematical formalisation of the language in terms of its syntax and
semantics. Then, we report bounds for the size of OTTR expansion—that is, of the data encoded by templates.
Finally, we overview our study of the data and combined complexity of an important decision problem associated
with the language and its fragments.
</blockquote>
</details></li>

<li>Martin G. Skjæveland, Daniel P. Lupp, Leif
Harald Karlsen, Johan W. Klüwer: <b>OTTR: Formal Templates for
Pattern-Based Ontology Engineering</b>. 349-377. In "Advances in
Pattern-based Ontology Engineering", Studies on the Semantic
Web 51, IOS Press 2021, ISBN 978-1-64368-174-0.</li>

<li><p>
<a id="orge5ccc75"></a>Martin G. Skjæveland. <b>The OTTR Template
Library</b>. In "Advances in Pattern-based Ontology Engineering",
Studies on the Semantic Web 51, IOS Press 2021, ISBN
978-1-64368-174-0. Presented at the 11th Workshop on Ontology
Design and Patterns - WOP2020, co-located with 19th
International Semantic Web Conference (ISWC 2020).
</p>
<details>
<summary>Abstract</summary>
<blockquote>
Reasonable Ontology Templates (OTTR) is a framework for representing encodings 
of ontology patterns and aimed to increase the efficiency and quality
of ontology engineering. This paper presents the current status and future ideas of
the main public library of OTTR templates. We describe the current contents of
the library, the rationale behind how templates are versioned and managed over
their lifetime, how templates are documented and published, and the technical
solution used.
</blockquote>
</details></li>

<li><p>
<a id="org8d65695"></a>Daniel P. Lupp, Melinda Hodkiewicz, and Martin
G. Skjæveland. <b><a href="http://ceur-ws.org/Vol-2757/SSWS2020_paper4.pdf">Template Libraries for Industrial Asset Maintenance: A Methodology for Scalable and Maintainable Ontologies</a></b>.  In: Thorsten Liebig, Achille Fokoue, Zhe Wu (eds)
Proceedings of the 13th International Workshop on Scalable
Semantic Web Knowledge Base Systems co-located with 19th
International Semantic Web Conference (ISWC
2020). CEUR. <a href="http://ceur-ws.org/Vol-2757/">http://ceur-ws.org/Vol-2757/</a>. 2020.
</p>
       <details>
       <summary>Abstract</summary>
       <blockquote>
Data in engineering industries is highly standardized and
informationdense, and usually distributed across many different
sources with incompatible formats and implicit semantics. As such, it
provides an ideal use case for application of semantic technologies
for data integration and access. However, adoption of semantic
technologies is hampered due to the complex set of competencies
required to construct a scalable and maintainable ontology. We present
a methodology for aiding domain experts and ontology engineers in
constructing and maintaining industry-viable ontologies using a
template-based approach for ontology modeling and instantiation. Using
the OTTR framework, the structure of the input formats and the
semantics of the target domain are modeled and maintained in separate
modularized template libraries. Data provided by domain experts is
mapped to these templates, allowing end-users to extend and amend the
model without the need to directly interact with semantic technology
languages and tools.  Our approach is demonstrated on a real-world use
case from the asset maintenance domain which has applicability to a
wide range of industries.
       </blockquote>
       </details></li>

<li><p>
<a id="orgd75ee02"></a>Martin G. Skjæveland, Daniel P. Lupp, Leif Harald
Karlsen, and Henrik Forssell. <b><a href="https://link.springer.com/content/pdf/10.1007%2F978-3-030-00671-6_28.pdf">Practical Ontology Pattern Instantiation, Discovery, and Maintenance with Reasonable Ontology Templates</a></b>  In: Vrandečić D. et al. (eds) The Semantic
Web&#x2014;ISWC 2018. ISWC 2018. LNCS
vol 11136. Springer. 2018. Nominated for best research paper award.
</p>
       <details>
       <summary>Abstract</summary>
       <blockquote>
Reasonable Ontology Templates (OTTR) is a language for representing
ontology modelling patterns in the form of parameterised
ontologies. Ontology templates are simple and powerful abstractions
useful for constructing, interacting with, and maintaining ontologies.
With ontology templates, modelling patterns can be uniquely identified
and encapsulated, broken down into convenient and manageable pieces,
instantiated, and used as queries. Formal relations defined over
templates support sophisticated maintenance tasks for sets of
templates, such as revealing redundancies and suggesting new templates
for representing implicit patterns. Ontology templates are designed
for practical use; an OWL vocabulary, convenient serialisation formats
for the semantic web and for terse specification of template
definitions and bulk instances are available, including an open source
implementation for using templates.  Our approach is successfully
tested on a real-world large-scale ontology in the engineering domain.
       </blockquote>
       </details></li>

<li><p>
<a id="orgb7c92fe"></a>Martin G. Skjæveland, Daniel P. Lupp, Leif
Harald Karlsen, and Henrik Forssell. <b><a href="http://ceur-ws.org/Vol-2180/paper-60.pdf">Practical Ontology Pattern
Instantiation, Discovery, and Maintenance with Reasonable Ontology Templates&#x2014;Demo paper</a></b>.  International Semantic Web
Conference (P&amp;D/Industry/BlueSky) 2018
</p>
       <details>
       <summary>Abstract</summary>
       <blockquote>
Reasonable Ontology Templates (OTTR) is a language for representing
ontology modelling patterns in the form of parameterised
ontologies. Ontology templates are simple and powerful abstractions
useful for constructing, interacting with and maintaining
ontologies. The templates’ simple yet formally precise structure
allows for formal relations to be defined over templates, supporting
sophisticated maintenance tasks for template libraries such as
revealing redundancies and suggesting new templates for representing
uncaptured modelling patterns.
       </blockquote>
       </details></li>

<li><p>
<a id="org5907bae"></a>Martin G. Skjæveland, Henrik Forssell, Johan Wilhelm Klüwer,
Daniel P. Lupp, Evgenij Thorstensen and Arild Waaler.
<b><a href="http://ceur-ws.org/Vol-2043/paper-04.pdf">Pattern-Based Ontology Design and Instantiation with Reasonable
Ontology Templates</a></b>. Research paper presented at <a href="http://ontologydesignpatterns.org/wiki/WOP:2017">8th Workshop on
Ontology Design and Patterns - WOP2017</a>. 2017.
</p>
       <details>
       <summary>Abstract</summary>
       <blockquote>
Reasonable Ontology Templates, OTTR s for short, are OWL ontology
macros capable of representing ontology design patterns (ODPs) and
closely integrating their use into ontology engineering. An OTTR is
itself an OWL ontology or RDF graph, annotated with a special purpose
OWL vocabulary. This allows OTTR s to be edited, debugged, published,
identified, instantiated, combined, used as queries and bulk
transformations, and maintained---all leveraging existing W3C
standards, best practices and tools. We show how such templates can
drive a technical framework and tools for a practical, efficient and
transparent use of ODP s in ontology design and instantiation. The
framework allows for a clear separation of the design of an ontology,
typically managed by ontology experts, and its bulk content, provided
by domain experts. We illustrate the approach by reconstructing the
published Chess Game ODP and producing linked chess data.
       </blockquote>
       </details></li>

<li><p>
Martin G. Skjæveland, Henrik Forssell, Johan W. Klüwer, Daniel
P. Lupp, Evgenij Thorstensen, Arild Waaler. <b><a href="http://ceur-ws.org/Vol-1963/paper597.pdf">Reasonable Ontology
Templates: APIs for OWL</a></b>. Poster paper presented at
<a href="https://iswc2017.semanticweb.org/">International Semantic Web Conference</a>. 2017
</p>
       <details>
       <summary>Abstract</summary>
       <blockquote>
Reasonable Ontology Templates, OTTRs for short, are OWL ontology
macros capable of representing ontology design patterns (ODPs) and
closely integrating their use into ontology engineering. An OTTR is
itself an OWL ontology or RDF graph, annotated with a special purpose
OWL vocabulary. This allows OTTR s to be edited, debugged, published,
identified, instantiated, combined, used as queries and bulk
transformations, and maintained---all leveraging existing W3C
standards, best practices and tools. We show how such templates can
drive a technical framework and tools for a practical, efficient and
transparent use of ontology design patterns in ontology design and
instantiation.
       </blockquote>
       </details></li>

<li><p>
<a id="org82bb7ab"></a>Henrik Forssell, Daniel P. Lupp, Martin G. Skjæveland, Evgenij
Thorstensen. <b><a href="http://ceur-ws.org/Vol-1879/paper34.pdf">Reasonable Macros for Ontology Construction and
Maintenance</a></b>. Poster paper presented at the <a href="https://project.inria.fr/dl2017/">Description Logics workshop</a>. 2017
</p>
       <details>
       <summary>Abstract</summary>
       <blockquote>
Creating and maintaining ontology knowledge bases are difficult
processes that can be improved by using macro or templating languages
that help structure the ontology engineering task and reduce
unnecessary repetitions of ontology patterns. However, since the
templates themselves need to be created and maintained, suitable tool
support for their maintenance is vital in order to ensure the quality
of the resulting knowledge base, and to lower the cost of its
construction and maintenance.  In this paper, we show that a simple
and powerful macro or templating language for description logic (DL)
knowledge bases can be defined in description logic itself. In other
words, DL allows for macros that are themselves DL knowledge bases;
maintenance and debugging for such macros can therefore be done using
existing DL reasoners, and does not require extra tool support. We
define such macros for the DL SROIQ, which underlies the W3C standard
OWL 2. We then show that notions of containment and other problems of
interest for such macros become standard reasoning problems supported
by existing reasoners. We explore the uses of such macros, showcase
how they can be used as restricted higher-order queries, and apply our
insights to the setting of data exchange.
       </blockquote>
       </details></li>
</ol>
</div>
</div>

<div id="outline-container-org4a83d81" class="outline-4">
<h4 id="org4a83d81">Foundations for Pattern-based ontology engineering</h4>
<div class="outline-text-4" id="text-org4a83d81">
<ol class="org-ol">
<li><a id="org43757c2"></a> Christian Kindermann, Martin G. Skjæveland.
A Survey of Syntactic Modelling Structures in Biomedical Ontologies
In: Monin P. et al. (eds) The Semantic Web&#x2014;ISWC 2022. ISWC 2022. LNCS to appear.</li>

<li>Christian Kindermann, Daniel P. Lupp, Martin G. Skjæveland,
Leif Harald Karlsen: Formal Relations over Ontology Patterns in
Templating Frameworks. 120-133. In "Advances in Pattern-based
Ontology Engineering", Studies on the Semantic Web 51, IOS
Press 2021, ISBN 978-1-64368-174-0.</li>

<li><p>
<a id="org011fc3d"></a>Daniel P. Lupp, Leif Harald Karlsen, and Martin
G. Skjæveland. <b><a href="http://ceur-ws.org/Vol-2195/research_paper_5.pdf">Making
a Case for Formal Relations over Ontology Patterns</a></b>. Short
paper presented at <a href="http://ontologydesignpatterns.org/wiki/WOP:2018">9th Workshop on Ontology Design and
Patterns - WOP2018</a>. 2018.
</p>
       <details>
       <summary>Abstract</summary>
       <blockquote>
There have recently been multiple frameworks proposed to formalize the
definition and instantiation of recurring patterns for ontology
construction and maintenance. Such formal frameworks can also provide
the means necessary for discussing how such patterns can be related to
one another, both syntactically and semantically. This has the
potential for organizing pattern libraries, robust handling of
maintenance tasks, such as redundancy removal, and defining heuristics
for what constitutes a “good” pattern. This short paper aims to
provide a common ground for discussions on formal relations between
ontology patterns. We discuss interesting relations with motivating
examples as well as state open questions concerning relations for
optimizing the creation, instantiation, and maintenance of ontology
patterns.
       </blockquote>
       </details></li>

<li><p>
<a id="org14a71ec"></a> Christian Kindermann, Daniel P. Lupp, Uli Sattler,
Evgenij Thorstensen. <b><a href="http://ceur-ws.org/Vol-2211/paper-22.pdf">Generating Ontologies from Templates: A
Rule-Based Approach for Capturing Regularity</a></b> In: Description
Logics 2018. 2018.
</p>
       <details>
       <summary>Abstract</summary>
       <blockquote>
We present a second-order language that can be used to succinctly
specify ontologies in a consistent and transparent manner.  This
language is based on ontology templates (OTTR), a framework for
capturing recurring patterns of axioms in ontological modelling. The
language, and our results are independent of any specific DL.  We
define the language and its semantics, including the case of
negation-as-failure, investigate reasoning over ontologies specified
using our language, and show results about the decidability of useful
reasoning tasks about the language itself. We also state and discuss
some open problems that we believe to be of interest.
       </blockquote>
       </details></li>
</ol>
</div>
</div>

<div id="outline-container-orgb826ba6" class="outline-4">
<h4 id="orgb826ba6">Use cases</h4>
<div class="outline-text-4" id="text-orgb826ba6">
<ol class="org-ol">
<li>Laura Ann Slaughter, Leif Harald Karlsen, Eveliina Päivikki Kallioniemi, Martin Georg Skjæveland.  
<b>Reusable Ontology Modelling Patterns for Biodiversity Data with Reasonable Ontology Templates (OTTR)</b> 
Biodiversity Information Science and Standards 6: e93939, doi:
<a href="https://doi.org/10.3897/biss.6.93939">https://doi.org/10.3897/biss.6.93939</a> (24 Aug 2022). Extended
abstract presented at The Biodiversity Information
Standards (TDWG) 2022.</li>

<li><a id="org68ce7c8"></a> Martin G. Skjæveland, Anders Gjerver,
Christian M. Hansen, Johan Wilhelm Klüwer, Morten R. Strand,
Arild Waaler, Per Øyvind Øverli. <b><a href="http://ceur-ws.org/Vol-2180/paper-90.pdf">Semantic Material Master Data
Management at Aibel</a></b> Industry paper presented at ISWC 2018.</li>
</ol>
</div>
</div>


<div id="outline-container-org93f8eb4" class="outline-4">
<h4 id="org93f8eb4">Master theses</h4>
<div class="outline-text-4" id="text-org93f8eb4">
<ul class="org-ul">
<li><p>
Snilsberg, Erik. <b><a href="https://www.duo.uio.no/handle/10852/100319">Reverse OTTR: A query language for RDF</a></b>. University of Oslo. 2022.
</p>
      <details>
      <summary>Abstract</summary>
      <blockquote>
Reasonable Ontology Templates (OTTR) is a recent template language for the modelling -and construction- of RDF knowledge graphs, which aims to tackle the issue that RDF itself is too low level for practical use. By emphasising useful design-principles, such as abstraction levels and the "Don't Repeat Yourself''-principle (DRY), OTTR is a promising solution, for which the industry has shown great interest. This thesis investigates the potential for the use of OTTR as a query language. OTTR templates model RDF graph patterns, and in the process known as expansion, constructs graphs from these patterns. Based on the idea that the reversal of the expansion process describes a query language for RDF graphs, this project formally defines Reverse OTTR, a query language for RDF with OTTR syntax. To this end, we first provide a formalization of the expansion process of OTTR and use this formalisation as the basis for the formalization of Reverse OTTR. Then, we formally show by structural induction how the input and output of the two languages relate, justifying the name of the language. Finally, we present a proof-of-concept implementation of Reverse OTTR and an experiment, which showcases the performance of the naive implementation for various language features.
      </blockquote>
      </details></li>
</ul>


<ul class="org-ul">
<li><p>
Marlen Jarholt. <b><a href="https://www.duo.uio.no/handle/10852/96925">Frog: Functions for ontologies — An extension for the OTTR-framework</a></b>. University of Oslo. 2022.
</p>
      <details>
      <summary>Abstract</summary>
      <blockquote>
Reasonable Ontology Templates (OTTR) is a language making it possible to compose
parameterised modelling patterns, known as templates, that we can instantiate to produce
an RDF graph and OWL ontologies. Hence, removing the repetitive and time-consuming
processes of producing RDF graphs over a domain. Using OTTR offers several benefits
compared to pure RDF: the Don't repeat yourself (DRY) principle, better abstraction,
uniform modelling, and separation of design and content. To instantiate templates, we
often use bOTTR and tabOTTR, which extract data from a tabular file or data sources.
OTTR templates can not perform calculations on argument terms. Consequently, we
need to perform calculations over terms before instantiating them. Therefore, the sources
that bOTTR and tabOTTR extract data from need to perform necessary calculations.
Each source type has different means to create calculations, thus, resulting in several
ways of manipulations for the same calculation. We believe that making it possible to
have one uniform means of performing calculations in templates will strengthen OTTR's
aforementioned benefits. Therefore, in this thesis, we design and implement a programing
language, Frog, that can perform manipulations inside templates, which aims to integrate
with OTTR seamlessly. Moreover, we evaluate if including a language like Frog into
OTTR enhances the acclaimed benefits.
      </blockquote>
      </details></li>
</ul>



<ul class="org-ul">
<li><p>
Shanshan Qu. <b><a href="https://www.duo.uio.no/handle/10852/96140">Visual Construction of Ontology Templates</a></b>. University of Oslo. 2022.
</p>
      <details>
      <summary>Abstract</summary>
      <blockquote>
OTTR is a powerful language for representing ontology modelling patterns. It is intended to improve the efficiency and quality of building and maintaining knowledge bases. 
Now, it is becoming more popular in industry to utilize OTTR templates to construct sustainable knowledge bases. As a result, a graphical language with visualization tools for OTTR templates is needed to lower the barrier for the adoption by a wider range of users.

A visual language for OTTR templates developed on UML principles with certain adjustments is the core contribution of the thesis.  The suggested visual language is a two-dimensional visualization that could be categorized as a UML-style node-link visualization. To evaluate the UML-based visualization, the nine principles of PoNT have been used as a basic guideline. A survey with user participation was carried out in order to test both the usability and the performance of this UML-based visual language. The analysis of the survey results has shown that our UML-style node-link visualization is an acceptable visualization even though it is not the best solution. In addition, a Java desktop application to translate the OTTR templates into visualization is also part of the contribution.

      </blockquote>
      </details></li>
</ul>



<ul class="org-ul">
<li><p>
Victoria Varzhel. <b><a href="http://urn.nb.no/URN:NBN:no-76414">Exploring the Use of Ontologies and Reasonable Ontology Templates (OTTR) within Health Registry Systems</a></b>. University of Oslo. 2019.
</p>
      <details>
      <summary>Abstract</summary>
      <blockquote>
In this thesis we explored the use of ontologies and Reasonable Ontology Templates (OTTR)
within the context of health registries in Norway. We contributed to further knowledge about
this topic by reusing the existing ontologies and applying OTTR templates to a real-life case -
health registries. The project starts with presenting the theoretical background about
ontologies, their components and languages, ontology reuse, design patterns and OTTR. The
presented use case is the use of health registries in Norway. Responsibility for the national
registries is shared among different institutions, which results in lack of standardisation and
data quality.
<br><br>
To answer the research questions, we reused the PICO and CSEO ontologies and designed the
OTTR templates for the health registry variables. Results demonstrated that (1) reuse of
biomedical ontologies occurs through merging ontologies and their modules, but it entails
manual effort from both an ontology engineer, and a domain expert; (2) despite some issues,
the OTTR templates can be applied to the real life case of health registry variables. The
created templates can potentially be used in a registry builder application where templates
will be used to construct an OWL file with the necessary variables for the registry.
      </blockquote>
      </details></li>
</ul>
</div>
</div>
</div>
</div>

<div id="outline-container-orgf566e7c" class="outline-2">
<h2 id="orgf566e7c">Videos</h2>
<div class="outline-text-2" id="text-orgf566e7c">
</div>
<div id="outline-container-orgf2cd36d" class="outline-4">
<h4 id="orgf2cd36d">Presentation: Motivation and Overview</h4>
<div class="outline-text-4" id="text-orgf2cd36d">
<p>
The aim of this screencast is to give a brief, but reasonably
complete overview of what OTTR is, and pointers to more information.
</p>

<p>
The screencast contains three parts; first, we motivate the need
for a template mechanism for ontology and knowledge base
engineering. Then, we present the Reasonable Ontology Templates
framework, show examples and explain its the features and
benefits. We end by giving pointers to more information.
</p>

<p>
The presentation contains few technical details and should be easy
to follow for anyone with basic understanding of RDF and OWL. 
</p>

<p>
The presentation is by Martin G. Skjæveland.
</p>

<iframe style="border: 1px solid #ccc;" src="https://player.vimeo.com/video/413131235" width="640" height="360"  allow="autoplay; fullscreen" allowfullscreen></iframe>
</div>
</div>


<div id="outline-container-org3471f11" class="outline-4">
<h4 id="org3471f11">Lecture: The (language) basics of OTTR</h4>
<div class="outline-text-4" id="text-org3471f11">
<p>
This is part of a lecture given in the course <a href="https://www.uio.no/studier/emner/matnat/ifi/IN3060/index-eng.html">IN3060 Semantic Technologies</a> given at the University of Oslo, spring 2021. The video
assumes only a very basic knowledge of the OTTR framework and covers
all the basics of the language constructs of OTTR in some depth. The
lecture is given by Leif Harald Karlsen.
</p>

<iframe style="border: 1px solid #ccc;" src="https://player.vimeo.com/video/546462264" width="640" height="360"  allow="autoplay; fullscreen" allowfullscreen></iframe>
</div>
</div>


<div id="outline-container-org104edac" class="outline-4">
<h4 id="org104edac">Live coding session: Incrementally building a template library</h4>
<div class="outline-text-4" id="text-org104edac">
<p>
The video shows live coding demo session of a top-down approach for
building a template library for a example use case. The chapter
assumes the reader is familiar with the basics of OTTR. The coding
session is using in emacs and a major mode for emacs (see <a href="https://gitlab.com/ottr/pub/emacs-stottr-mode">https://gitlab.com/ottr/pub/emacs-stottr-mode</a>) that defines
syntax highlighting for the stOTTR syntax and basic functionality from
the standard Lutra CLI (the reference implementation of the OTTR
project). The coding session is done by Daniel Lupp.
</p>

<iframe style="border: 1px solid #ccc;" src="https://player.vimeo.com/video/547161487" width="640" height="360"  allow="autoplay; fullscreen" allowfullscreen></iframe>
</div>
</div>

<div id="outline-container-orga9ea313" class="outline-4">
<h4 id="orga9ea313">Presentation: The Core OTTR template library</h4>
<div class="outline-text-4" id="text-orga9ea313">
<p>
Presentation of the core OTTR template library, available at
<a href="http://tpl.ottr.xyz">http://tpl.ottr.xyz</a>, design principles, content, structure,
documentation and technical platform. By Martin G. Skjæveland.
</p>

<iframe style="border: 1px solid #ccc;" src="https://player.vimeo.com/video/475013375" width="640" height="360"  allow="autoplay; fullscreen" allowfullscreen></iframe>
</div>
</div>

<div id="outline-container-orgeeab58a" class="outline-4">
<h4 id="orgeeab58a">Presentation: Ontology patterns for industrial ontologies: The READI use case</h4>
<div class="outline-text-4" id="text-orgeeab58a">
<p>
Presentation by Johan W. Klüwer and Martin G. Skjæveland for
SemWeb.Pro 2020: <a href="https://semweb.pro/semwebpro-2020.html">https://semweb.pro/semwebpro-2020.html</a>. 
</p>

<details>
<summary>Abstract</summary>
<blockquote>
Our presentation will describe how requirements management in capital
industries can benefit from ontology-based methods. Our use case is
the READI Joint Industry Project in digitalised requirements for the
Norwegian Continental Shelf (offshore Oil and Gas). We propose a new
kind of service, integrating industrial ontologies with the templates
needed to use them correctly.
<br><br>
READI aims to improve the specification, implementation, and
verification of requirements. A particular aim is to evolve the INCOSE
guidelines for writing requirements, so that recent innovations in
intelligent data can be exploited. READI uses ontologies, following
W3C's OWL 2 standard in the intended way, where constraints are
subject to precise Description Logic reasoning. This will support and
partially automate work processes, improving development and use of
requirements across design and operations.
<br><br>
To provide a common, shared language of industrial assets and
processes in the form of OWL ontologies is crucial. This requires a
broad-ranging collaborative effort between subject matter experts and
ontology modellers; while challenging, the approach has already been
proven successful in capital projects. We obtain a clear separation
between a generic vocabulary (classes and relations), requirements
expressed using the vocabulary (norms as rules), and industrial assets
described with the vocabulary (individual instances).
<br><br>
Agreement on common terminology is however not enough. We also need to
ensure that the vocabularies are applied in a uniform way. To this
end, READI adopts the Reasonable Ontology Templates (OTTR) language
and framework. Ontology patterns are developed to match the kinds of
facts that need to be formalised, then captured in OTTR
templates. With a library of OTTR templates, we can secure uniformity:
as ontologies are built, as they are applied to integration of
existing data sources, and in analysis and reporting.
<br><br>
To make the ontology-based approach practical for the industry, a new
kind of repository service is needed, one that provides both
ontologies and the templates for using them in projects. In our
presentation, we will demonstrate how READI builds a platform for such
a service, compliant with web best practices including Linked Data,
and exploiting the template library facilities of the OTTR reference
implementation Lutra.
</blockquote>
</details>


<iframe style="border: 1px solid #ccc;" src="https://player.vimeo.com/video/477957408" width="640" height="360"  allow="autoplay; fullscreen" allowfullscreen></iframe>
</div>
</div>


<div id="outline-container-org56312a9" class="outline-4">
<h4 id="org56312a9">Demo: Weblutra demonstration</h4>
<div class="outline-text-4" id="text-org56312a9">
<p>
Simple walk-though of WebLutra, the web version of Lutra. By Martin
G. Skjæveland.
</p>

<iframe style="border: 1px solid #ccc;" src="https://player.vimeo.com/video/413132899" width="640" height="360"  allow="autoplay; fullscreen" allowfullscreen></iframe>
</div>
</div>
</div>


<div id="outline-container-org1287766" class="outline-2">
<h2 id="org1287766">Tutorials and Demos</h2>
<div class="outline-text-2" id="text-org1287766">
<p>
Tutorials and demos are kept on seperate pages:
</p>

<ul class="org-ul">
<li><p>
<a href="./event/2020-11-023-iswc/">Pattern-based knowledge base construction</a> at <a href="https://iswc2020.semanticweb.org/">ISWC 2020</a>
</p>
   <details>
   <summary>Abstract</summary>
   <blockquote>
A major barrier for the adoption of semantic web technologies in industry is the construction of sustainable knowledge bases; domain experts and end-users often find semantic web languages and tools difficult to use.

Reasonable Ontology Templates (OTTR) is a language and framework that allows abstractions or modelling patterns over RDF/OWL to be succinctly represented and instantiated. It is designed to address the needs and expertise domain experts, ontology engineers, and data managers in the process of creating and maintaining high-quality, maintainable knowledge bases.

The tutorial will give an introduction to the OTTR framework, discuss modelling best practices for sustainable knowledge bases using templates and demonstrate practical use templates. The tutorial is relevant for semantic web practitioners and ontology engineers who are eager to make efficient use of modelling patterns in their work, and for information managers from industry looking for possible ways to introduce ontology development into their enterprise.
   </blockquote>
   </details></li>

<li><p>
<a href="./event/2019-10-267-iswc/">Scalable construction of sustainable knowledge bases</a> at
<a href="https://iswc2019.semanticweb.org/tutorials/">ISWC 2019</a>
</p>
   <details>
   <summary>Abstract</summary>
   <blockquote>
A major barrier for the adoption of semantic web technologies in industry is the construction of sustainable knowledge bases; domain experts and end-users often find semantic web languages and tools difficult to use.

Reasonable Ontology Templates (OTTR) is a language and framework that allows abstractions or modelling patterns over RDF/OWL to be succinctly represented and instantiated. It is designed to address the needs and expertise domain experts, ontology engineers, and data managers in the process of creating and maintaining high-quality, maintainable knowledge bases.

The tutorial is relevant for semantic web practitioners and ontology engineers who are eager to make efficient use of modelling patterns in their work, and for information managers from industry looking for possible ways to introduce ontology development into their enterprise.
   </blockquote>
   </details></li>

<li><p>
<a href="./event/2019-06-02-eswc/">Practical and Scalable Pattern-based Ontology Engineering with
Reasonable Ontology Templates</a> at <a href="https://2019.eswc-conferences.org">ESWC 2019</a>
</p>
   <details>
   <summary>Abstract</summary>
   <blockquote>
Learn how to build, maintain and interact with knowledge bases via higher level abstractions and modelling patterns using the OTTR templating framework. 
   </blockquote>
   </details></li>

<li><p>
<a href="./event/2019-02-05-iof/">International Industrial Ontologies Foundery (IOF) Workshops 2019 Tutorial: Ontology patterns in practice</a>
</p>
   <details>
   <summary>Abstract</summary>
   <blockquote>
A major bottleneck for the successful adoption of ontology-based information systems in industry is the construction and maintenance of large-scale ontologies. This tutorial will introduce Reasonable Ontology Templates (OTTR), a framework for ontology construction and maintenance based on efficient representation and instantiation of modelling patterns.

The participants will learn how such ontology abstraction mechanisms can be beneficial for building, interacting with, and maintaining large-scale ontologies. The tutorial will consist of presentations, plenary and individual exercises using open source tooling. Participants that wish to take part in the individual exercises should bring a laptop with Java 8 installed.
   </blockquote>
   </details></li>

<li><a href="./event/2018-10-08-iswc/">Online demo for ISWC 2018 demo paper</a> + <a href="./event/2018-10-08-iswc/poster.pdf">poster</a></li>
<li><a href="./event/2017-10-23-iswc/">Companion text ISWC 2017 poster paper</a>  + <a href="./event/2017-10-23-iswc/poster.pdf">poster</a></li>
</ul>


<figure id="org47382a4">
<img src="./img/poster-iswc18.png" alt="Poster for ISWC 2018" />

<figcaption><span class="figure-number">Figure 3: </span>Poster for ISWC 2018</figcaption>
</figure>

<figure id="org81b80fd">
<img src="./img/poster-iswc17.png" alt="Poster for ISWC 2017" />

<figcaption><span class="figure-number">Figure 4: </span>Poster for ISWC 2017</figcaption>
</figure>
</div>
</div>

<div id="outline-container-org45ffdc0" class="outline-2">
<h2 id="org45ffdc0">Talks</h2>
<div class="outline-text-2" id="text-org45ffdc0">
<ul class="org-ul">
<li><a href="https://ontocommons.eu/news-events/events/workshop-ontology-engineering-and-knowledge-graphs-tool-ecosystem">OntoCommons Workshop on Ontology Engineering and Knowledge Graphs tool ecosystem</a> 2022-08-31, <i>Reasonable Ontology Templates</i>, Martin G. Skjæveland.</li>

<li><a href="./event/2022-05-11-user-forum/">3rd OTTR user forum</a> 2022-05-11, OTTR team + invited talks.</li>

<li>UiO/SIRIUS general assembly, <i>Ontology Engineering Research
Program + Reasonable Ontology Templates</i>, Martin G. Skjæveland.</li>

<li><a href="./event/2021-06-18-user-forum/">2nd OTTR user forum</a> 2021-06-18, OTTR team + invited talks.</li>

<li><a href="./event/2021-01-28-user-forum/">1st OTTR user forum</a> 2021-01-28, OTTR team + invited talks.</li>

<li>Presentation for Strategic Advisory Committee at the Faculty of
Mathematics and Natural Sciences UiO 2019-11-28, <i>OTTR Templates</i>,
Martin G. Skjæveland.</li>

<li>OSDU workshop 2019-10-08, <i>OTTR: Scalable construction of sustainable knowledge bases</i>, Martin G. Skjæveland and Dag Hovland.</li>

<li>UiO/SIRIUS General Assembly 2019-05-23, <i>Ontology engineering for industrial applications using Reasonable Ontology Templates(OTTR)</i>, Martin G. Skjæveland.</li>

<li>CapGemini semantics workshop 2019-04-26, <i>Reasonable Ontology
Templates</i>, Martin G. Skjæveland.</li>

<li>ISWC 2018 research track: <a href="./event/2018-10-08-iswc/iswc2018-research.pdf">Reasonable Ontology Templates</a>, Martin G. Skjæveland.</li>

<li>ISWC 2018 industry track: <a href="./event/2018-10-08-iswc/iswc2018-industry.pdf">Semantic Material Master Data
Management at Aibel</a>, Anders Gjerver (Aibel) and
Martin G. Skjæveland.</li>

<li>UiO/SIRIUS Seminar 2018-08-27, <i>Reasonable Ontology Templates</i>,
Martin G. Skjæveland, Leif Harald Karlsen and Daniel Lupp.</li>

<li>UiO/SIRIUS workshop with University of Western Australia
2018-08-15, <i>Reasonable Ontology Templates</i>, Martin
G. Skjæveland, Leif Harald Karlsen and Daniel Lupp.</li>

<li>Bielefeld University visit 2018-06-05, <i>Reasonable Ontology
Templates</i>, Martin G. Skjæveland, Leif Harald Karlsen and Daniel
Lupp.</li>

<li>Uni Bremen visit 2018-06-04, <i>Reasonable Ontology Templates</i>,
Martin G. Skjæveland and Leif Harald Karlsen.</li>

<li><a href="https://www.meetup.com/SIRIUS-Industrial-Ontology-Colloquium/events/249630274/">SIRIUS' Industrial Ontology Colloquium</a> 2018-04-13: <a href="https://www.slideshare.net/MartinGSkjveland/programming-semantics-practical-applications-of-ottr">Programming semantics:
practical applications of OTTR</a>, Leif Harald Karlsen.</li>

<li>TU Wien visit 2017-11-30, <i>Reasonable Ontology Templates&#x2014;When macros are more than just macros</i>, Daniel Lupp.</li>

<li><a href="http://ontologydesignpatterns.org/wiki/WOP:2017">Workshop on Ontology Design and Patterns 2017</a>: <a href="./event/2017-10-21-wop/wop2017.pdf">Reasonable
Ontology Templates</a>, Martin G. Skjæveland.</li>

<li>SIRIUS' Industrial Ontology Colloquium 2017-09-29: <i>Reasonable Ontology
Templates</i>, Martin G. Skjæveland.</li>

<li>SIRIUS' Industrial Ontology Colloquium 2017-03-03: <i>Ontology
Templates</i>, Martin G. Skjæveland.</li>
</ul>
</div>
</div>
<div id="outline-container-orgb7ce037" class="outline-2">
<h2 id="orgb7ce037">OTTR logos</h2>
<div class="outline-text-2" id="text-orgb7ce037">
<p>
The OTTR logo is created by SHS. It comes in different variations:
</p>

<div id="logos">
<div class="image"><img src="./logo/OTTR.jpg" alt="OTTR logo"><p>OTTR</p></div>
<div class="image"><img src="./logo/lutra.jpg" alt="Lutra logo"><p>Lutra</p></div>
<div class="image"><img src="./logo/mOTTR.jpg" alt="mOTTR logo"><p>mOTTR</p></div>
<div class="image"><img src="./logo/rOTTR.jpg" alt="rOTTR logo"><p>rOTTR</p></div>
<div class="image"><img src="./logo/wOTTR.jpg" alt="wOTTR logo"><p>wOTTR</p></div>
<div class="image"><img src="./logo/stOTTR.svg" alt="stOTTR logo"><p>stOTTR</p></div>
<div class="image"><img src="./logo/stOTTR-new.jpg" alt="stOTTR logo"><p>stOTTR</p></div>
<div class="image"><img src="./logo/bOTTR.jpg" alt="bOTTR logo"><p>bOTTR</p></div>
<div class="image"><img src="./logo/tabOTTR.png" alt="tabOTTR logo"><p>tabOTTR</p></div>
<div class="image"><img src="./logo/tutOTTR.png" alt="tutOTTR logo"><p>tutOTTR</p></div>
<div class="image"><img src="./logo/demOTTR.png" alt="demOTTR logo"><p>demOTTR</p></div>
<div class="image"><img src="./logo/pOTTR.png" alt="pOTTR logo"><p>pOTTR</p></div>
<div class="image"><img src="./logo/lOTTR.jpg" alt="lOTTR logo"><p>lOTTR</p></div>
<div class="image"><img src="./logo/docTTR.jpg" alt="docTTR logo"><p>docTTR</p></div>
<div class="image"><img src="./logo/emacsOTTR.jpg" alt="emacs-ottr-toolkit"><p>emacs-ottr-toolkit</p></div>
<div class="image"><img src="./logo/OTTR-log.jpg" alt="OTTR-log"><p>OTTR-log</p></div>
<div class="image"><img src="./logo/alexottr.jpg" alt="Alexander Kielland"><p>Alexander Kielland</p></div>
</div>
</div>
</div>


<div id="outline-container-orga6dc90a" class="outline-2">
<h2 id="orga6dc90a">News archive</h2>
<div class="outline-text-2" id="text-orga6dc90a">
<dl class="org-dl">
<dt>2024-12-18</dt><dd><a href="https://drops.dagstuhl.de/entities/document/10.4230/TGDK.2.2.5">The complete set of specification of the OTTR framework has been publised as part of a special issue on resources in Transactions on Graph Data and Knowledge (TGDK)</a>. It collects years of developments on the framework and ideas for future work.</dd>

<dt>2024-06-18</dt><dd>Erik Snilsberg will present our extended abstract on the <a href="https://ceur-ws.org/Vol-3739/abstract-24.pdf">Foundations of Ontology Template Language OTTR</a> at the <a href="https://dl2024.w.uib.no/overview/">DL Workshop 2024</a>.</dd>

<dt>2024-02-02</dt><dd>If you are interested in making use of OTTR and semantic technologies in your data pipelines and for different reasons wish to use something else than Lutra, check out <a href="https://github.com/DataTreehouse/maplib">maplib</a> developed by <a href="https://www.data-treehouse.com/">Data Treehouse</a>: "maplib is a knowledge graph construction library for building RDF knowledge graphs using template expansion (OTTR Templates)."</dd>

<dt>2023-11-09</dt><dd><a href="https://www.grundfos.com/">Grundfos</a>' Industrial Ontology Engineering Platform uses OTTR. Read all about it in their ISWC 2023 industry paper: <a href="https://ceur-ws.org/Vol-3632/ISWC2023_paper_502.pdf">Building an Industrial Ontology Engineering Platform</a>, and in <a href="https://medium.com/wallscope/developing-ontology-tools-with-grundfos-d84a961bd4cd">https://medium.com/wallscope/developing-ontology-tools-with-grundfos-d84a961bd4cd</a>.</dd>

<dt>2023-11-07</dt><dd>Moritz Blum et al. shares <a href="https://ceur-ws.org/Vol-3636/paper8.pdf">Insights from an OTTR-centric Ontology Engineering Methodology</a> at WOP@ISWC2023.</dd>

<dt>2023-04-19</dt><dd>Martin G. Skjæveland is presenting OTTR to the Ontolog Forum on "Helping scientific researchers make better use of ontologies": <a href="https://ontologforum.com/index.php/ConferenceCall_2023_04_19">https://ontologforum.com/index.php/ConferenceCall_2023_04_19</a>, Video recording and slides available.</dd>

<dt>2022-08-17</dt><dd>On 2022-08-31 we are giving a talk on OTTR at <a href="https://ontocommons.eu/news-events/events/workshop-ontology-engineering-and-knowledge-graphs-tool-ecosystem">OntoCommons Workshop on Ontology Engineering and Knowledge Graphs tool ecosystem</a>. Registration is free and open!</dd>

<dt>2022-08-15</dt><dd>Our paper on abbreviations for complex OWL expressions has been accepted at <a href="https://kgsum.github.io/">KGSum 2022</a>.</dd>

<dt>2022-07-08</dt><dd>Our paper on syntactic modelling structures in ontologies  [<a href="#org43757c2">1</a>] has been accepted at <a href="https://iswc2022.semanticweb.org/">ISWC 2022</a>.</dd>

<dt>2022-04-04</dt><dd>Please register for the <a href="./event/2022-05-11-user-forum/">3nd OTTR user forum</a> which will take place physically and co-located with the general assembly of SIRIUS.</dd>

<dt>2022-03-16</dt><dd>We are very happy to see that Veronika Heimsbakk, CapGemini is giving a tutorial on OTTR <b>and</b> a talk on the use of OTTR "Growing Your Graph With OTTR" at
The Knowledge Graph Conference
(<a href="https://www.knowledgegraph.tech/">https://www.knowledgegraph.tech/</a>) More information
here:
<ul class="org-ul">
<li><a href="https://www.knowledgegraph.tech/speakers/veronika-heimsbakk/">https://www.knowledgegraph.tech/speakers/veronika-heimsbakk/</a></li>
<li><a href="https://veronahe.wordpress.com/2022/05/03/the-shape-of-otters/">https://veronahe.wordpress.com/2022/05/03/the-shape-of-otters/</a></li>
<li><a href="https://github.com/veleda/ottr-masterclass">https://github.com/veleda/ottr-masterclass</a></li>
</ul></dd>

<dt>2021-05-28</dt><dd>Join the <a href="./event/2021-06-18-user-forum/">2nd OTTR user forum</a>.  Registration is free.</dd>

<dt>2021-05-10</dt><dd>Two new introductional videos about OTTR are
published: one video lecture by Leif Harald Karlsen
on the basic language constructs of OTTR, and one
live coding session by Daniel Lupp on how to
incrementally build a small template library using a
top-down approach.</dd>

<dt>2020-12-11</dt><dd>Please join us at the <a href="./event/2021-01-28-user-forum/">1st OTTR user forum</a> for the
latest news and discussions with OTTR users. Invited
talk by Johan W. Klüwer.  Registration is free.</dd>

<dt>2020-10-01</dt><dd>Our paper on the design principles, content and
management of the core OTTR template library has
been accepted for <a href="http://ontologydesignpatterns.org/wiki/WOP:2020">WOP2020</a>. The paper will be part of
the upcoming book: "Advances in Pattern-based
Ontology Engineering".</dd>

<dt>2020-09-13</dt><dd>Our paper "Template Libraries for Industrial Asset
Maintenance: A Methodology for Scalable and
Maintainable Ontologies" [<a href="#org8d65695">5</a>] with Melinda Hodkiewicz has
been accepted for <a href="http://www.ssws-ws.org/SSWS2020/">SSWS 2020</a>.</dd>

<dt>2020-05-20</dt><dd>Extended versions of our WOP17 and WOP18 papers "
Pattern-Based Ontology Design and Instantiation with
Reasonable Ontology Templates" [<a href="#org5907bae">8</a>] and "Making a Case
for Formal Relations over Ontology Patterns" [<a href="#org011fc3d">3</a>] will
appear as chapters in the forthcoming book "Advances
in Pattern-based Ontology Engineering" published by
IOS Press.</dd>

<dt>2020-03-04</dt><dd>We will be giving a tutorial on OTTR templates at
<a href="https://iswc2020.semanticweb.org/">ISWC 2020</a> titled: <a href="./event/2020-11-023-iswc/">Pattern-based knowledge base construction</a>.</dd>

<dt>2019-10-24</dt><dd>The pOTTR OTTR Primer is released! See
<a href="https://primer.ottr.xyz/">https://primer.ottr.xyz/</a></dd>

<dt>2019-02-14</dt><dd>We will be giving a tutorial on OTTR templates at
<a href="https://iswc2019.semanticweb.org/tutorials/">ISWC 2019</a> titled: <a href="./event/2019-10-267-iswc/">Scalable construction of sustainable knowledge bases</a>.</dd>

<dt>2019-02-01</dt><dd>Lutra version 0.5.0-alpha-3 is released:
<a href="https://gitlab.com/ottr/lutra/lutra/releases">https://gitlab.com/ottr/lutra/lutra/releases</a>. Please
test and give us feedback.</dd>

<dt>2018-12-03</dt><dd>We will be giving a tutorial on OTTR templates at
<a href="https://2019.eswc-conferences.org/tutorials-workshops/">ESWC 2019</a> titled: <a href="./event/2019-06-02-eswc/">Practical and Scalable
Pattern-based Ontology Engineering with Reasonable
Ontology Templates</a>.</dd>
<dt>2018-11-20</dt><dd>OTTR templates will be presented at the
<a href="https://www.dnvgl.com/events/international-industrial-ontologies-workshops-134292">International Industrial Ontologies Workshops</a> in
Oslo February 2019: <a href="./event/2019-02-05-iof/">Ontology patterns in practice</a>.</dd>
<dt>2018-10-10</dt><dd>Our ISWC research paper [<a href="#orgd75ee02">6</a>] is nominated for
best paper award.</dd>
<dt>2018-06-27</dt><dd>Our short paper "Making a Case for Formal Relations
over Ontology Patterns" [<a href="#org011fc3d">3</a>] is accepted for
the Workshop of Ontology Design Patterns (WOP2018)</dd>
<dt>2018-06-18</dt><dd>Our ISWC demo paper [<a href="#orgb7c92fe">7</a>] demonstrating the
results of our ISWC research paper [<a href="#orgd75ee02">6</a>] is
accepted.</dd>
<dt>2018-05-28</dt><dd>Our paper "Practical Ontology Pattern Instantiation,
Discovery, and Maintenance with Reasonable Ontology
Templates" [<a href="#orgd75ee02">6</a>] is accepted for ISWC's
research track.</dd>
</dl>
</div>
</div>

<div id="outline-container-orgf8b8421" class="outline-2">
<h2 id="orgf8b8421">Contact</h2>
<div class="outline-text-2" id="text-orgf8b8421">
<p>
If you have a question or technical issue with OTTR, please use our
gitter forum: <a href="https://gitter.im/ottr-talk">https://gitter.im/ottr-talk</a>
</p>

<p>
Or, use one of these issue trackers:
</p>

<ul class="org-ul">
<li><a href="https://gitlab.com/ottr/lutra/lutra/issues">Lutra</a></li>
<li><a href="https://gitlab.com/ottr/templates/issues">Template library</a></li>
<li>Specifications: <a href="https://gitlab.com/ottr/language/mOTTR/issues">mOTTR</a>, <a href="https://gitlab.com/ottr/language/wOTTR/issues">wOTTR</a>, <a href="https://gitlab.com/ottr/language/stOTTR/issues">stOTTR</a>, <a href="https://gitlab.com/ottr/language/tabOTTR/issues">tabOTTR</a>, <a href="https://gitlab.com/ottr/language/bOTTR/issues">bOTTR</a></li>
</ul>

<p>
Iff your inquiry does not suit the format of an issue, you can
email the lead developer of OTTR, Martin G. Skjæveland
<code>martige@ifi.uio.no</code>.
</p>
</div>
</div>

<div id="outline-container-org154753c" class="outline-2">
<h2 id="org154753c">Appendix</h2>
<div class="outline-text-2" id="text-org154753c">
</div>
<div id="outline-container-orgc9a9eae" class="outline-3">
<h3 id="orgc9a9eae">Pronunciation</h3>
<div class="outline-text-3" id="text-orgc9a9eae">
<p>
We pronounce OTTR as "otter", the animal, see, e.g.,
<a href="https://dictionary.cambridge.org/dictionary/english/otter">https://dictionary.cambridge.org/dictionary/english/otter</a>.
</p>
</div>
</div>

<div id="outline-container-prefixes" class="outline-3">
<h3 id="prefixes">Prefixes</h3>
<div class="outline-text-3" id="text-prefixes">
<p>
These are the prefixes used on this page:
</p>

<pre class="example" id="org1bc7748">
@prefix rdf: 	  &lt;http://www.w3.org/1999/02/22-rdf-syntax-ns#&gt; . 
@prefix rdfs: 	  &lt;http://www.w3.org/2000/01/rdf-schema#&gt; . 
@prefix owl: 	  &lt;http://www.w3.org/2002/07/owl#&gt; . 
@prefix xsd: 	  &lt;http://www.w3.org/2001/XMLSchema#&gt; . 

@prefix ottr: 	  &lt;http://ns.ottr.xyz/0.4/&gt; . 
@prefix ax: 	  &lt;http://tpl.ottr.xyz/owl/axiom/0.1/&gt; . 
@prefix rstr: 	  &lt;http://tpl.ottr.xyz/owl/restriction/0.1/&gt; .
@prefix o-pizza:  &lt;http://tpl.ottr.xyz/pizza/0.1/&gt; .

@prefix ex: 	  &lt;http://example.com/ns#&gt; . 
</pre>
</div>
</div>
</div>

<div id="outline-container-org119999c" class="outline-2 footer">
<h2 id="org119999c">_footer</h2>
<div class="outline-text-2" id="text-org119999c">
</div> <!-- end toc-content -->
</div> <!-- end right -->
</div>
</div>
</div>
</body>
</html>
